#include "StdAfx.h"
#include "Impressora.h"

CImpressora::CImpressora(void)
: m_iUltimoErro(0)
{
}

CImpressora::~CImpressora(void)
{
	if (m_hImpressora != NULL) {
		FechaImpressora();
	}
}

// Funo responsvel por iniciar a comunicao com o Driver da impressora
BOOL CImpressora::AbreImpressora( LPSTR pcNomeImpressora )
{
	m_pNomeImpressora = pcNomeImpressora;
	BOOL bSucesso = OpenPrinter( pcNomeImpressora, &m_hImpressora, NULL );
	if (bSucesso){
		m_iUltimoErro = SUCESSO;
	} else {
		m_iUltimoErro = ERRO_FALHA_ABERTURA;
	}
	return bSucesso;
}

// Imprime o texto na impressora
BOOL CImpressora::ImprimeTexto(LPSTR pcTextoP)
{
	BOOL bSucesso = false;
	DOC_INFO_1 DocInfo;	
	// Preenche a estrutura com as informaes do "documento"
	LPSTR pNomeDocumento = new CHAR[100];
	strcpy_s( pNomeDocumento, 100, TEXT("Documeto") );	
	strcat_s( pNomeDocumento, 100, m_pNomeImpressora);
	DocInfo.pDocName = pNomeDocumento;
	DocInfo.pOutputFile = NULL;
	DocInfo.pDatatype = TEXT("RAW");
	// Informa ao spooler de impresso o inicio do documento.
	LPSTR pcTexto = new CHAR[1024];
	strcpy_s( pcTexto, 1024, pcTextoP);
	strcat_s( pcTexto, 1024, TEXT("\n") );
	DWORD dwJob = StartDocPrinter( m_hImpressora, 1, (LPBYTE)&DocInfo );
	if (dwJob != 0 ){
		// Inicia pgina.
		if( StartPagePrinter( m_hImpressora ) ) {
			// Envia as informaes para a impressora.
			LPBYTE lpData = (LPBYTE) pcTexto;
			DWORD dwCount = (DWORD) strlen(pcTexto);
			DWORD dwBytesWritten= 0;
			if( WritePrinter( m_hImpressora, lpData, dwCount, &dwBytesWritten ) )
			{
				if ( dwCount == dwBytesWritten ){
					bSucesso = true;
				} else {
					m_iUltimoErro = ERRO_IMPRESSAO_INCOMPLETA;
				}
				EndPagePrinter( m_hImpressora );							
				EndDocPrinter( m_hImpressora );			
			}			
		} else {
			EndDocPrinter( m_hImpressora );
			m_iUltimoErro = ERRO_INICIAR_PAGINA;
		}			
	} else {
		m_iUltimoErro = ERRO_INICIAR_DOC;
	}

	if (bSucesso){
		m_iUltimoErro = SUCESSO;
	} 
	
	return bSucesso;
}

// Fecha a comunicao com o Driver da impressora
BOOL CImpressora::FechaImpressora(void)
{
	BOOL bSucesso = ClosePrinter( m_hImpressora );
	if (bSucesso){
		m_iUltimoErro = SUCESSO;
	} else {
		m_iUltimoErro = ERRO_FALHA_FECHAMENTO;
	}
	return bSucesso;
}

// L o ltimo erro que ocorreu
int CImpressora::LeUltimoErro(void)
{
	return m_iUltimoErro;
}
