unit UPrincipal;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TfrmPrincipal = class(TForm)
    btnConexao: TButton;
    mmTexto: TMemo;
    btnImprimir: TButton;
    btnCortar: TButton;
    Label1: TLabel;
    cmbTestes: TComboBox;
    btnTestar: TButton;
    procedure btnConexaoClick(Sender: TObject);
    procedure btnImprimirClick(Sender: TObject);
    procedure btnCortarClick(Sender: TObject);
    procedure btnTestarClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;


var
  frmPrincipal: TfrmPrincipal;

implementation

uses UCWind;

var
  Wind: CWind;
  bConectado: Boolean;
{$R *.dfm}

procedure TfrmPrincipal.btnConexaoClick(Sender: TObject);
var
  bSucesso: Boolean;
begin
  if ( Wind = nil ) then
    Wind := CWind.Create();

  if ( btnConexao.Caption = 'Conectar' ) then
    begin
      bSucesso:= Wind.Conectar('LPT1');
      if (bSucesso) then
      begin
        bConectado := TRUE;
        btnConexao.Caption := 'Desconectar';
      end;
    end
  else
    begin
      bSucesso := Wind.Desconectar();
      if (bSucesso) then
      begin
        btnConexao.Caption := 'Conectar';
        bConectado := FALSE;
      end;
    end;
end;


procedure TfrmPrincipal.btnImprimirClick(Sender: TObject);
var
  iNumCaracteresImpresso: Integer;
begin
  if (bConectado) then
  begin
    iNumCaracteresImpresso := Wind.ImprimeTexto(mmTexto.Text);

    if ( iNumCaracteresImpresso > 0 ) then
      Application.MessageBox('Documento Impresso com Sucesso!', 'Wind Demo');
  end
  else
    Application.MessageBox('A Impressora no esta conectada', 'Wind Demo', MB_ICONWARNING);

end;

procedure TfrmPrincipal.btnCortarClick(Sender: TObject);
begin
  if (bConectado) then
  begin
    Wind.AcionarGuilhotina();
    ShowMessage('Envio do comando realizado !!!');
  end;
end;

procedure TfrmPrincipal.btnTestarClick(Sender: TObject);
var nOption: Integer;
begin
  nOption := cmbTestes.ItemIndex;

  Case nOption of
    0 :
    begin
      Wind.DefineTextoCodBarTopo();
      ShowMessage('Envio do comando realizado !!!');
    end;
    1 :
    begin
      Wind.DefineTextoCodBarBase();
      ShowMessage('Envio do comando realizado !!!');
    end;
    2 :
    begin
      Wind.ImprimeCodBarUPCA();
      ShowMessage('Envio do comando realizado !!!');
    end;
    3 :
    begin
      Wind.ImprimeCodBarUPCE();
      ShowMessage('Envio do comando realizado !!!');
    end;
    4 :
    begin
      Wind.ImprimeCodBarEAN13();
      ShowMessage('Envio do comando realizado !!!');
    end;
    5 :
    begin
      Wind.ImprimeCodBarEAN8();
      ShowMessage('Envio do comando realizado !!!');
    end;
    6 :
    begin
      Wind.ImprimeCodBarCode39();
      ShowMessage('Envio do comando realizado !!!');
    end;
    7 :
    begin
      Wind.ImprimeCodBarITF();
      ShowMessage('Envio do comando realizado !!!');
    end;
    8 :
    begin
      Wind.ImprimeCodBarCODABAR();
      ShowMessage('Envio do comando realizado !!!');
    end;
    9 :
    begin
      Wind.ImprimeCodBarCode93();
      ShowMessage('Envio do comando realizado !!!');
    end;
    10:
    begin
      Wind.ImprimeCodBarCode128();
      ShowMessage('Envio do comando realizado !!!');
    end;
    11:
    begin
      Wind.ImprimeCodBarISBN();
      ShowMessage('Envio do comando realizado !!!');
    end;
    12:
    begin
      Wind.ImprimeCodBarMSI();
      ShowMessage('Envio do comando realizado !!!');
    end;
    13:
    begin
      Wind.ImprimeCodBarPLESSEY();
      ShowMessage('Envio do comando realizado !!!');
    end;

  else ShowMessage('Selecione um valor da lista !!!');
  end;

end;

procedure TfrmPrincipal.FormCreate(Sender: TObject);
begin
cmbTestes.ItemIndex:=0;
end;

end.
