#pragma once

// Opero realizada com sucesso.
const int SUCESSO = 1; 
// Falha na abertura da impressora. 
const int ERRO_FALHA_ABERTURA = -1; 
//Nmero de bytes impressos  menor do que os bytes presentes no buffer de impresso.
const int ERRO_IMPRESSAO_INCOMPLETA = -2; 
//Falha ao iniciar documento para impresso.
const int ERRO_INICIAR_DOC = -3; 
//Falha ao iniciar pagina do documento de impresso.
const int ERRO_INICIAR_PAGINA = -4; 
//Falha ao fechar impressora
const int ERRO_FALHA_FECHAMENTO = -5; 

//Classe responsvel por gerenciar a comunicao com o driver da impressora
class CImpressora
{
public:
	CImpressora(void);
	~CImpressora(void);
	// Funo responsvel por iniciar a comunicao com o Driver da impressora
	BOOL AbreImpressora(LPSTR pcNomeImpressora);
private:
	// Handle para a impressora
	HANDLE m_hImpressora;
public:
	// Imprime o texto na impressora
	BOOL ImprimeTexto(LPSTR pcTexto);
	// Fecha a comunicao com o Driver da impressora
	BOOL FechaImpressora(void);
	// Nome do Driver da Impressora
	LPSTR m_pNomeImpressora;
private:
	// ltimo erro ocorrido
	int m_iUltimoErro;
public:
	// L o ltimo erro que ocorreu
	int LeUltimoErro(void);
};
