unit UDemoNix;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Printers, WinSpool;

type
  TfrmDemoNix = class(TForm)
    lstLogImp: TListBox;
    lblTextoImp: TLabel;
    txtTextoImp: TEdit;
    btnImprime: TButton;
    btnCortar: TButton;
    btnAbreGaveta: TButton;
    procedure btnImprimeClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure btnCortarClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure btnAbreGavetaClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmDemoNix: TfrmDemoNix;
  HPrinter : THandle;

implementation

{$R *.dfm}

procedure TfrmDemoNix.btnImprimeClick(Sender: TObject);
var aDevice, aDriver, aPort: array[0..255] of char;
    aMode : THandle;
    Doc:Doc_Info_1;
    iRet:Longword;
    iSize: Cardinal;
    s:String;
begin
  Printer.GetPrinter(aDevice, aDriver, aPort, aMode);
  lstLogImp.Items.Add('Imprimindo texto ' +  txtTextoImp.Text + '...');
  Doc.pDocName    := 'Teste';
  Doc.pOutputFile := '';
  Doc.pDatatype   := 'RAW';
  StartDocPrinter(HPrinter, 1, @Doc);
  s := String(txtTextoImp.Text) + #10;
  iSize := Strlen(PChar(s));
  WritePrinter(HPrinter, @s[1], iSize , iRet);
  EndDocPrinter(HPrinter);
end;

procedure TfrmDemoNix.FormCreate(Sender: TObject);
var strPrinterName : string;
    nPrinterIndex : integer;
    i: integer;
    aDevice, aDriver, aPort: array[0..255] of char;
    aMode : THandle;
begin
  strPrinterName := 'NIX(U) 1';
  lstLogImp.Items.Add('Listando Impressoras instaladas...');
  for i:=0 to Printer.Printers.Count - 1 do
  begin
    Printer.PrinterIndex := i;
    Printer.GetPrinter(aDevice, aDriver, aPort, aMode);
    lstLogImp.Items.Add('0'+IntToStr(i) + ' ' + String(aDevice));
  end;
  lstLogImp.Items.Add(' ');
  nPrinterIndex := Printer.Printers.IndexOf( strPrinterName );
  Printer.PrinterIndex := nPrinterIndex;
  Printer.GetPrinter(aDevice, aDriver, aPort, aMode);
  lstLogImp.Items.Add('Impressora ' +  String( aDevice ) + ' selecionada.');
  OpenPrinter(PChar( strPrinterName ), HPrinter, nil);
end;

procedure TfrmDemoNix.btnCortarClick(Sender: TObject);
var Doc:Doc_Info_1;
    iRet:Longword;
    s:String;
begin
  Doc.pDocName    := 'Teste';
  Doc.pOutputFile := '';
  Doc.pDatatype   := 'RAW';
  lstLogImp.Items.Add('Enviando Corte de Papel');
  StartDocPrinter(HPrinter, 1, @Doc);
  s := #27#119; // Corte de Papel
  WritePrinter(HPrinter, @s[1], 2, iRet);
  EndDocPrinter(HPrinter);
end;

procedure TfrmDemoNix.FormDestroy(Sender: TObject);
begin
  ClosePrinter(HPrinter);
end;

procedure TfrmDemoNix.btnAbreGavetaClick(Sender: TObject);
var Doc:Doc_Info_1;
    iRet:Longword;
    s:String;
begin
  Doc.pDocName    := 'Abre Gaveta';
  Doc.pOutputFile := '';
  Doc.pDatatype   := 'RAW';
  lstLogImp.Items.Add('Enviando comando para abrir gaveta');
  StartDocPrinter(HPrinter, 1, @Doc);
  s := #27#118#200; // Abre Gaveta
  WritePrinter(HPrinter, @s[1], 3, iRet);
  EndDocPrinter(HPrinter);
end;

end.
